'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _isEqual2 = require('lodash/isEqual');

var _isEqual3 = _interopRequireDefault(_isEqual2);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function defaultMergeProps(response, ownProps) {
  var _ref = response || {},
      json = _ref.json;

  return (0, _extends3.default)({}, ownProps, json);
}

exports.default = function (getPathSets, mergeProps) {
  var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      _ref2$defer = _ref2.defer,
      defer = _ref2$defer === undefined ? false : _ref2$defer,
      _ref2$pure = _ref2.pure,
      pure = _ref2$pure === undefined ? true : _ref2$pure,
      loadingComponent = _ref2.loadingComponent;

  if (!mergeProps) {
    mergeProps = defaultMergeProps;
  }
  var Loading = loadingComponent;
  return function (WrappedComponent) {
    var Resolve = function (_React$Component) {
      (0, _inherits3.default)(Resolve, _React$Component);

      function Resolve(props, context) {
        (0, _classCallCheck3.default)(this, Resolve);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Resolve.__proto__ || (0, _getPrototypeOf2.default)(Resolve)).call(this, props, context));

        _this.onModelChange = function () {
          _this.subscribe(_this.props);
        };

        _this.eventEmitter = context.falcor.eventEmitter;
        _this.falcor = context.falcor.model;

        _this.state = {
          loading: true,
          response: null
        };
        return _this;
      }

      (0, _createClass3.default)(Resolve, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          if (!defer) {
            this.listenAndSubscribe();
          }
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (defer) {
            this.listenAndSubscribe();
          }
        }
      }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
          if (this.version !== this.falcor.getVersion()) {
            return true;
          }
          return !pure || !(0, _isEqual3.default)(this.props, nextProps) || !(0, _isEqual3.default)(this.state, nextState);
        }
      }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
          this.version = this.falcor.getVersion();
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          if (!pure || !(0, _isEqual3.default)(nextProps, this.props)) {
            this.subscribe(nextProps);
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.cleanup();
        }
      }, {
        key: 'listenAndSubscribe',
        value: function listenAndSubscribe() {
          this.eventEmitter.on('change', this.onModelChange);
          this.subscribe(this.props);
        }
      }, {
        key: 'computePathSets',
        value: function computePathSets(props) {
          var pathSets = (0, _isFunction3.default)(getPathSets) ? getPathSets(props) : getPathSets;
          process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(typeof pathSets !== 'undefined', '"pathSets" is undefined') : void 0;
          return pathSets || [];
        }
      }, {
        key: 'subscribe',
        value: function subscribe(props) {
          var _falcor,
              _this2 = this;

          this.tryUnsubscribe();

          var pathSets = this.computePathSets(props);
          this.subscription = (_falcor = this.falcor).get.apply(_falcor, (0, _toConsumableArray3.default)(pathSets)).subscribe(function (response) {
            // HACK avoid server-side rendering setState() no-op
            // this is happened when calling renderToString(),
            // this callback is run after component is rendered,
            // which triggering the warning
            if (_this2.updater && _this2.updater.transaction && _this2.updater.transaction._isInTransaction === false) {
              return;
            }

            _this2.setState({
              loading: false,
              response: response
            });
          });
        }
      }, {
        key: 'tryUnsubscribe',
        value: function tryUnsubscribe() {
          if (this.subscription) {
            this.subscription.dispose();
            this.subscription = null;
          }
        }
      }, {
        key: 'cleanup',
        value: function cleanup() {
          this.eventEmitter.removeListener('change', this.onModelChange);
          this.eventEmitter = null;

          this.tryUnsubscribe();
          this.falcor = null;
          this.version = null;
        }
      }, {
        key: 'render',
        value: function render() {
          if (this.state.loading) {
            return Loading ? _react2.default.createElement(Loading, this.props) : null;
          }
          return _react2.default.createElement(WrappedComponent, mergeProps(this.state.response, this.props));
        }
      }]);
      return Resolve;
    }(_react2.default.Component);

    Resolve.contextTypes = {
      falcor: _react.PropTypes.object.isRequired
    };

    return (0, _hoistNonReactStatics2.default)(Resolve, WrappedComponent);
  };
};
//# sourceMappingURL=falcorGet.js.map